export declare const backgroundColor: {
    readonly white: 7;
    readonly black: 40;
    readonly grey: 100;
    readonly red: 41;
    readonly green: 42;
    readonly yellow: 43;
    readonly blue: 44;
    readonly magenta: 45;
    readonly cyan: 46;
    readonly brightRed: 101;
    readonly brightGreen: 102;
    readonly brightYellow: 103;
    readonly brightBlue: 104;
    readonly brightMagenta: 105;
    readonly brightCyan: 106;
};
export declare class Formatter {
    private parts;
    private text;
    constructor(text: string);
    static create(text: string): Formatter;
    counter(current: number, total: number, pad?: string): this;
    dim(): this;
    bold(): this;
    underline(): this;
    info(): this;
    italic(): this;
    success(): this;
    fail(): this;
    gray(): this;
    bg(color: keyof typeof backgroundColor): this;
    [Symbol.toPrimitive](): string;
}
export declare const format: (text: string) => Formatter;
export declare const getLargestStringLength: (arr: string[]) => number;
