import type { ParseAssertionOptions } from '../@types/assert.js';
import * as nodeAssert from 'node:assert';
declare function doesNotThrow(block: () => unknown, message?: string | ParseAssertionOptions['message']): void;
declare function doesNotThrow(block: () => unknown, error: nodeAssert.AssertPredicate, message?: ParseAssertionOptions['message']): void;
declare function throws(block: () => unknown, message?: ParseAssertionOptions['message']): void;
declare function throws(block: () => unknown, error: nodeAssert.AssertPredicate, message?: ParseAssertionOptions['message']): void;
declare function rejects(block: (() => Promise<unknown>) | Promise<unknown>, message?: ParseAssertionOptions['message']): Promise<void>;
declare function rejects(block: (() => Promise<unknown>) | Promise<unknown>, error: nodeAssert.AssertPredicate, message?: ParseAssertionOptions['message']): Promise<void>;
declare function doesNotReject(block: (() => Promise<unknown>) | Promise<unknown>, message?: ParseAssertionOptions['message']): Promise<void>;
declare function doesNotReject(block: (() => Promise<unknown>) | Promise<unknown>, error: nodeAssert.AssertPredicate, message?: ParseAssertionOptions['message']): Promise<void>;
export declare const assert: ((value: unknown, message?: ParseAssertionOptions["message"]) => void) & {
    ok: (value: unknown, message?: ParseAssertionOptions["message"]) => void;
    equal: (actual: unknown, expected: unknown, message?: ParseAssertionOptions["message"]) => void;
    deepEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions["message"]) => void;
    strictEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions["message"]) => void;
    deepStrictEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions["message"]) => void;
    doesNotMatch: (value: string, regExp: RegExp, message?: ParseAssertionOptions["message"]) => void;
    doesNotReject: typeof doesNotReject;
    throws: typeof throws;
    doesNotThrow: typeof doesNotThrow;
    notEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions["message"]) => void;
    notDeepEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions["message"]) => void;
    notStrictEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions["message"]) => void;
    notDeepStrictEqual: (actual: unknown, expected: unknown, message?: ParseAssertionOptions["message"]) => void;
    match: (value: string, regExp: RegExp, message?: ParseAssertionOptions["message"]) => void;
    ifError: (value: unknown, message?: ParseAssertionOptions["message"]) => void;
    fail: (message?: ParseAssertionOptions["message"]) => void;
    rejects: typeof rejects;
};
export {};
