"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.assert = void 0;
const nodeAssert = __importStar(require("assert"));
const parse_assertion_js_1 = require("../helpers/parse-assertion.js");
const get_runtime_js_1 = require("../helpers/get-runtime.js");
const ok = (value, message) => {
    (0, parse_assertion_js_1.parseAssertion)(() => {
        nodeAssert.ok(value);
    }, { message });
};
const equal = (actual, expected, message) => {
    (0, parse_assertion_js_1.parseAssertion)(() => {
        nodeAssert.equal(actual, expected);
    }, { message });
};
const deepEqual = (actual, expected, message) => {
    (0, parse_assertion_js_1.parseAssertion)(() => nodeAssert.deepEqual(actual, expected), { message });
};
const strictEqual = (actual, expected, message) => {
    (0, parse_assertion_js_1.parseAssertion)(() => nodeAssert.strictEqual(actual, expected), { message });
};
const deepStrictEqual = (actual, expected, message) => {
    (0, parse_assertion_js_1.parseAssertion)(() => nodeAssert.deepStrictEqual(actual, expected), {
        message,
    });
};
const notEqual = (actual, expected, message) => {
    (0, parse_assertion_js_1.parseAssertion)(() => nodeAssert.notEqual(actual, expected), {
        message,
    });
};
const notDeepEqual = (actual, expected, message) => {
    (0, parse_assertion_js_1.parseAssertion)(() => nodeAssert.notDeepEqual(actual, expected), { message });
};
const notStrictEqual = (actual, expected, message) => {
    (0, parse_assertion_js_1.parseAssertion)(() => nodeAssert.notStrictEqual(actual, expected), {
        message,
    });
};
const notDeepStrictEqual = (actual, expected, message) => {
    (0, parse_assertion_js_1.parseAssertion)(() => nodeAssert.notDeepStrictEqual(actual, expected), {
        message,
    });
};
const ifError = (value, message) => {
    (0, parse_assertion_js_1.parseAssertion)(() => {
        nodeAssert.ifError(value);
    }, {
        message,
        defaultMessage: 'Expected no error, but received an error',
        hideDiff: true,
        throw: true,
    });
};
/* c8 ignore start */
const fail = (message) => {
    (0, parse_assertion_js_1.parseAssertion)(() => {
        nodeAssert.fail(message);
    }, {
        message,
        defaultMessage: 'Test failed intentionally',
        hideDiff: true,
    });
};
function doesNotThrow(block, errorOrMessage, message) {
    (0, parse_assertion_js_1.parseAssertion)(() => {
        if (typeof errorOrMessage === 'function' ||
            errorOrMessage instanceof RegExp ||
            typeof errorOrMessage === 'object') {
            nodeAssert.doesNotThrow(block, errorOrMessage, message);
        }
        else {
            const msg = typeof errorOrMessage === 'string' ? errorOrMessage : message;
            nodeAssert.doesNotThrow(block, msg);
        }
    }, {
        message: typeof errorOrMessage === 'string' ? errorOrMessage : message,
        defaultMessage: 'Expected function not to throw',
        hideDiff: true,
        throw: true,
    });
}
function throws(block, errorOrMessage, message) {
    if (typeof errorOrMessage === 'function' ||
        errorOrMessage instanceof RegExp ||
        typeof errorOrMessage === 'object') {
        (0, parse_assertion_js_1.parseAssertion)(() => nodeAssert.throws(block, errorOrMessage), {
            message,
            defaultMessage: 'Expected function to throw',
            hideDiff: true,
        });
    }
    else {
        const msg = typeof errorOrMessage !== 'undefined' ? errorOrMessage : message;
        (0, parse_assertion_js_1.parseAssertion)(() => nodeAssert.throws(block, message), {
            message: msg,
            defaultMessage: 'Expected function to throw',
            hideDiff: true,
        });
    }
}
function rejects(block, errorOrMessage, message) {
    return __awaiter(this, void 0, void 0, function* () {
        yield (0, parse_assertion_js_1.parseAssertion)(() => __awaiter(this, void 0, void 0, function* () {
            if (typeof errorOrMessage === 'function' ||
                errorOrMessage instanceof RegExp ||
                typeof errorOrMessage === 'object') {
                yield nodeAssert.rejects(block, errorOrMessage, message);
            }
            else {
                const msg = typeof errorOrMessage === 'string' ? errorOrMessage : message;
                yield nodeAssert.rejects(block, msg);
            }
        }), {
            message: typeof errorOrMessage === 'string' ? errorOrMessage : message,
            defaultMessage: 'Expected promise to be rejected with specified error',
            hideDiff: true,
            throw: true,
        });
    });
}
function doesNotReject(block, errorOrMessage, message) {
    return __awaiter(this, void 0, void 0, function* () {
        yield (0, parse_assertion_js_1.parseAssertion)(() => __awaiter(this, void 0, void 0, function* () {
            if (typeof errorOrMessage === 'function' ||
                errorOrMessage instanceof RegExp ||
                typeof errorOrMessage === 'object')
                yield nodeAssert.doesNotReject(block, errorOrMessage, message);
            else
                yield nodeAssert.doesNotReject(block, message);
        }), {
            message: typeof errorOrMessage === 'string' ? errorOrMessage : message,
            defaultMessage: 'Got unwanted rejection',
            hideDiff: true,
            throw: true,
        });
    });
}
/* c8 ignore start */
const match = (value, regExp, message) => {
    if (typeof get_runtime_js_1.nodeVersion === 'number' && get_runtime_js_1.nodeVersion < 12) {
        throw new Error('match is available from Node.js 12 or higher');
    }
    (0, parse_assertion_js_1.parseAssertion)(() => nodeAssert === null || nodeAssert === void 0 ? void 0 : nodeAssert.match(value, regExp), {
        message,
        actual: 'Value',
        expected: 'RegExp',
        defaultMessage: 'Value should match regExp',
    });
};
/* c8 ignore stop */
/* c8 ignore start */
const doesNotMatch = (value, regExp, message) => {
    if (typeof get_runtime_js_1.nodeVersion === 'number' && get_runtime_js_1.nodeVersion < 12) {
        throw new Error('doesNotMatch is available from Node.js 12 or higher');
    }
    (0, parse_assertion_js_1.parseAssertion)(() => nodeAssert.doesNotMatch(value, regExp), {
        message,
        actual: 'Value',
        expected: 'RegExp',
        defaultMessage: 'Value should not match regExp',
    });
};
/* c8 ignore stop */
exports.assert = Object.assign((value, message) => ok(value, message), {
    ok,
    equal,
    deepEqual,
    strictEqual,
    deepStrictEqual,
    doesNotMatch,
    doesNotReject,
    throws,
    doesNotThrow,
    notEqual,
    notDeepEqual,
    notStrictEqual,
    notDeepStrictEqual,
    match,
    ifError,
    fail,
    rejects,
}
/* c8 ignore next */ // c8 bug
);
