import type { End, StartScriptOptions, StartServiceOptions } from '../@types/background-process.js';
/**
 *
 * Starts a file in a background process
 *
 * Useful for servers, APIs, etc.
 */
export declare const startService: (file: string, options?: StartServiceOptions) => Promise<{
    end: End;
}>;
/**
 *
 * Starts a script (package.json) or task (deno.json) in a background process
 *
 * By default, it uses **npm**, but you can costumize it using the `runner` option.
 *
 * Useful for servers, APIs, etc.
 */
export declare const startScript: (script: string, options?: StartScriptOptions) => Promise<{
    end: End;
}>;
