"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.describe = describe;
const node_process_1 = require("process");
const format_js_1 = require("../helpers/format.js");
const logs_js_1 = require("../helpers/logs.js");
const indentation_js_1 = require("../configs/indentation.js");
function describe(arg1, arg2) {
    return __awaiter(this, void 0, void 0, function* () {
        /* c8 ignore stop */
        let title;
        let cb;
        let options;
        const isPoku = typeof (node_process_1.env === null || node_process_1.env === void 0 ? void 0 : node_process_1.env.FILE) === 'string' && (node_process_1.env === null || node_process_1.env === void 0 ? void 0 : node_process_1.env.FILE.length) > 0;
        const FILE = node_process_1.env.FILE;
        if (typeof arg1 === 'string') {
            title = arg1;
            if (typeof arg2 === 'function')
                cb = arg2;
            else
                options = arg2;
        }
        else if (typeof arg1 === 'function') {
            cb = arg1;
            options = arg2;
        }
        if (title) {
            indentation_js_1.indentation.hasDescribe = true;
            const { background, icon } = options || {};
            const message = `${cb ? (0, format_js_1.format)('◌').dim() : icon || '☰'} ${cb ? (0, format_js_1.format)(isPoku ? `${title} › ${(0, format_js_1.format)(`${FILE}`).italic().gray()}` : /* c8 ignore next */ title).dim() : (0, format_js_1.format)(title).bold() || ''}`;
            const noBackground = !background;
            if (noBackground)
                (0, logs_js_1.write)((0, format_js_1.format)(message).bold());
            else {
                (0, logs_js_1.write)((0, format_js_1.format)(` ${message} `).bg(typeof background === 'string' ? background : 'grey'));
            }
        }
        if (typeof cb !== 'function')
            return;
        const start = (0, node_process_1.hrtime)();
        const resultCb = cb();
        /* c8 ignore next */
        if (resultCb instanceof Promise)
            yield resultCb;
        const end = (0, node_process_1.hrtime)(start);
        if (title) {
            const total = (end[0] * 1e3 + end[1] / 1e6).toFixed(6);
            indentation_js_1.indentation.hasDescribe = false;
            (0, logs_js_1.write)(`${(0, format_js_1.format)(`● ${title}`).success().bold()} ${(0, format_js_1.format)(`› ${total}ms`).success().dim()}`);
        }
    });
}
