"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.exit = void 0;
/* c8 ignore start */
const node_process_1 = __importDefault(require("process"));
const hr_js_1 = require("../helpers/hr.js");
const poku_js_1 = require("../configs/poku.js");
const format_js_1 = require("../helpers/format.js");
const logs_js_1 = require("../helpers/logs.js");
const files_js_1 = require("../configs/files.js");
const time_js_1 = require("../helpers/time.js");
const exit = (code, quiet) => {
    const isPoku = poku_js_1.results.success > 0 || poku_js_1.results.fail > 0;
    !quiet &&
        node_process_1.default.on('exit', (code) => {
            if (isPoku) {
                (0, hr_js_1.hr)();
                (0, logs_js_1.write)(`    ${(0, format_js_1.format)(`Start at › ${(0, format_js_1.format)(`${(0, time_js_1.setTime)(files_js_1.finalResults.started)}`).bold()}`).dim()}`);
                (0, logs_js_1.write)(`    ${(0, format_js_1.format)('Duration ›').dim()} ${(0, format_js_1.format)(`${files_js_1.finalResults.time}ms`).bold().dim()} ${(0, format_js_1.format)(`(±${(0, time_js_1.toSecs)(files_js_1.finalResults.time)} seconds)`).dim()}`);
                (0, logs_js_1.write)(`  ${(0, format_js_1.format)(`Test Files › ${(0, format_js_1.format)(String(files_js_1.fileResults.success.size + files_js_1.fileResults.fail.size)).bold()}`).dim()}`);
                (0, hr_js_1.hr)();
                (0, logs_js_1.write)(`${(0, format_js_1.format)(` PASS › ${poku_js_1.results.success} `).bg('green')} ${(0, format_js_1.format)(` FAIL › ${poku_js_1.results.fail} `).bg(poku_js_1.results.fail === 0 ? 'grey' : 'red')}`);
                (0, hr_js_1.hr)();
            }
            (0, logs_js_1.write)(`${(0, format_js_1.format)('Exited with code').dim()} ${(0, format_js_1.format)(String(code)).bold()[code === 0 ? 'success' : 'fail']()}\n`);
        });
    node_process_1.default.exit(code === 0 ? 0 : 1);
};
exports.exit = exit;
node_process_1.default.on('unhandledRejection', (reason) => {
    console.error('unhandledRejection', reason);
    node_process_1.default.exit(1);
});
node_process_1.default.on('uncaughtException', (err) => {
    console.error('uncaughtException', err);
    node_process_1.default.exit(1);
});
/* c8 ignore stop */
