"use strict";
/* c8 ignore start */
/**
 * This method will be removed in a future release to use `list-files.ts` instead.
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.publicListFiles = void 0;
const node_process_1 = require("process");
const node_fs_1 = require("fs");
const node_path_1 = __importDefault(require("path"));
const list_files_js_1 = require("./list-files.js");
const isDir = (fullPath) => (0, node_fs_1.statSync)(fullPath).isDirectory();
const envFilter = ((_a = node_process_1.env.FILTER) === null || _a === void 0 ? void 0 : _a.trim())
    ? new RegExp((0, list_files_js_1.escapeRegExp)(node_process_1.env.FILTER), 'i')
    : null;
const listFiles = (dirPath, files = [], configs) => {
    const currentFiles = (0, node_fs_1.readdirSync)((0, list_files_js_1.sanitizePath)(dirPath));
    const defaultRegExp = /\.(test|spec)\./i;
    const filter = (envFilter
        ? envFilter
        : (configs === null || configs === void 0 ? void 0 : configs.filter) instanceof RegExp
            ? configs.filter
            : defaultRegExp) || defaultRegExp;
    const exclude = (configs === null || configs === void 0 ? void 0 : configs.exclude)
        ? Array.isArray(configs.exclude)
            ? configs.exclude
            : [configs.exclude]
        : undefined;
    for (const file of currentFiles) {
        const fullPath = (0, list_files_js_1.sanitizePath)(node_path_1.default.join(dirPath, file));
        if (/node_modules/.test(fullPath))
            continue;
        if (exclude && exclude.some((regex) => regex.test(fullPath)))
            continue;
        if (isDir(fullPath))
            listFiles(fullPath, files, configs);
        else if (filter.test(fullPath))
            files.push(fullPath);
    }
    return files;
};
const publicListFiles = (targetDir, configs) => listFiles((0, list_files_js_1.sanitizePath)(targetDir), [], configs);
exports.publicListFiles = publicListFiles;
/* c8 ignore stop */
