/**
 * Returns an array containing the ID of all processes listening to the specified port
 */
export declare const getPIDs: ((port: number | number[]) => Promise<number[]>) & {
    /**
     * Returns an array containing the ID of all processes listening to the specified range port
     */
    range: (startsAt: number, endsAt: number) => Promise<number[]>;
};
export declare const kill: {
    /**
     * Terminates the specified process ID
     */
    pid: (PID: number | number[]) => Promise<void>;
    /**
     * Terminates all processes listening on the specified port
     */
    port: (port: number | number[]) => Promise<void>;
    /**
     * Terminates all processes listening on the specified range ports
     */
    range: (startsAt: number, endsAt: number) => Promise<void>;
};
