"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test = test;
/* c8 ignore next */ // c8 bug
const node_process_1 = require("process");
const each_js_1 = require("../configs/each.js");
const indentation_js_1 = require("../configs/indentation.js");
const format_js_1 = require("../helpers/format.js");
const logs_js_1 = require("../helpers/logs.js");
function test(...args) {
    return __awaiter(this, void 0, void 0, function* () {
        /* c8 ignore stop */
        let message;
        let cb;
        const isPoku = typeof (node_process_1.env === null || node_process_1.env === void 0 ? void 0 : node_process_1.env.FILE) === 'string' && (node_process_1.env === null || node_process_1.env === void 0 ? void 0 : node_process_1.env.FILE.length) > 0;
        const FILE = node_process_1.env.FILE;
        if (typeof each_js_1.each.before.cb === 'function' && each_js_1.each.before.test) {
            const beforeResult = each_js_1.each.before.cb();
            /* c8 ignore next */
            if (beforeResult instanceof Promise)
                yield beforeResult;
        }
        if (typeof args[0] === 'string') {
            message = args[0];
            cb = args[1];
        }
        else
            cb = args[0];
        if (message) {
            indentation_js_1.indentation.hasTest = true;
            (0, logs_js_1.write)(isPoku
                ? (0, format_js_1.format)(`◌ ${message} › ${(0, format_js_1.format)(`${FILE}`).italic().gray()}`).dim() /* c8 ignore next */ // c8 bug
                : /* c8 ignore next */
                    (0, format_js_1.format)(`◌ ${message}`).dim());
        }
        const start = (0, node_process_1.hrtime)();
        const resultCb = cb();
        /* c8 ignore next */
        if (resultCb instanceof Promise)
            yield resultCb;
        const end = (0, node_process_1.hrtime)(start);
        if (typeof each_js_1.each.after.cb === 'function' && each_js_1.each.after.test) {
            const afterResult = each_js_1.each.after.cb();
            /* c8 ignore next */
            if (afterResult instanceof Promise)
                yield afterResult;
        }
        /* c8 ignore start */
        if (message) {
            const total = (end[0] * 1e3 + end[1] / 1e6).toFixed(6);
            indentation_js_1.indentation.hasTest = false;
            (0, logs_js_1.write)(`${(0, format_js_1.format)(`● ${message}`).success().bold()} ${(0, format_js_1.format)(`› ${total}ms`).success().dim()}`);
        }
        /* c8 ignore stop */
    });
}
