"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readFile = exports.stat = void 0;
exports.readdir = readdir;
const node_fs_1 = require("fs");
function readdir(path, options) {
    return new Promise((resolve, reject) => {
        if (options === null || options === void 0 ? void 0 : options.withFileTypes) {
            (0, node_fs_1.readdir)(path, { withFileTypes: true }, (err, entries) => {
                if (err)
                    return reject(err);
                resolve(entries);
            });
            return;
        }
        (0, node_fs_1.readdir)(path, (err, files) => {
            if (err)
                return reject(err);
            resolve(files);
        });
    });
}
const stat = (path) => {
    return new Promise((resolve, reject) => {
        (0, node_fs_1.stat)(path, (err, stats) => {
            if (err)
                return reject(err);
            resolve(stats);
        });
    });
};
exports.stat = stat;
const readFile = (path, encoding = 'utf-8') => new Promise((resolve, reject) => {
    (0, node_fs_1.readFile)(path, encoding, (err, data) => {
        if (err)
            return reject(err);
        resolve(data);
    });
});
exports.readFile = readFile;
