"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.padStart = void 0;
/**
 * Custom implementations of `padStart` for compatibility with Node.js version 6.
 */
const padStart = (str, targetLength, padString) => {
    padString = !padString ? ' ' : String(padString);
    if (str.length >= targetLength)
        return str;
    const paddingLength = targetLength - str.length;
    let fullPadString = padString.repeat(Math.ceil(paddingLength / padString.length));
    fullPadString = fullPadString.slice(0, paddingLength);
    return fullPadString + str;
};
exports.padStart = padStart;
