"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.afterEach = exports.beforeEach = void 0;
const format_js_1 = require("../helpers/format.js");
const logs_js_1 = require("../helpers/logs.js");
const eachCore = (type, fileRelative, configs) => __awaiter(void 0, void 0, void 0, function* () {
    if (typeof (configs === null || configs === void 0 ? void 0 : configs[type]) !== 'function')
        return true;
    const cb = configs[type];
    /* c8 ignore next */
    if (typeof cb !== 'function')
        return true;
    (0, logs_js_1.write)(`    ${(0, format_js_1.format)('◯').dim().info()} ${(0, format_js_1.format)(`${cb}: ${cb.name || 'anonymous function'}`)
        .dim()
        .italic()}`);
    try {
        const resultCb = cb();
        /* c8 ignore next */
        if (resultCb instanceof Promise)
            yield resultCb;
        return true;
        /* c8 ignore start */
    }
    catch (error) {
        (0, logs_js_1.write)((0, format_js_1.format)(`    ✘ ${type} callback failed ${(0, format_js_1.format)(`› ${cb}`).dim()}`)
            .fail()
            .bold());
        (0, logs_js_1.write)((0, format_js_1.format)(`      ├─ Who's trying to run this ${type}?`).fail());
        (0, logs_js_1.write)((0, format_js_1.format)(`      │ └─ ${(0, format_js_1.format)(fileRelative).fail().underline()}`).fail());
        if (error instanceof Error) {
            (0, logs_js_1.write)((0, format_js_1.format)(`      ├─ Message:`).fail());
            (0, logs_js_1.write)((0, format_js_1.format)(`      │ └─ ${error.message}`).fail());
        }
        return false;
    }
    /* c8 ignore stop */
    /* c8 ignore next */ // c8 bug
});
const beforeEach = (fileRelative, configs) => __awaiter(void 0, void 0, void 0, function* () {
    if (configs === null || configs === void 0 ? void 0 : configs.beforeEach)
        return yield eachCore('beforeEach', fileRelative, configs);
    return true;
});
exports.beforeEach = beforeEach;
const afterEach = (fileRelative, configs) => __awaiter(void 0, void 0, void 0, function* () {
    if (configs === null || configs === void 0 ? void 0 : configs.afterEach)
        return yield eachCore('afterEach', fileRelative, configs);
    return true;
});
exports.afterEach = afterEach;
